%=======================================================================
%To solve optimization problem:
%Install Portfolio Safeguard (PSG)
%Create a new subfolder in ...\PSG\MATLAB:
%..\PSG\MATLAB\problem_Beyond_Black_Litterman_3_32_EF
%Download and unpack the following zipped file from 'Data' to the created folder:
%'Mat_data_problem_Beyond_Black_Litterman_3_32_EF.zip'
%Run program 'problem_Beyond_Black_Litterman_3_32_EF.m'
%=======================================================================

clc;
clear;
addpath('..');

%Load data:
load('.\problem_Beyond_Black_Litterman_data_3_32_EF.mat');

%Define input arguments:
N_Par = 20;
options.PlotGraph = 'On';
options.PlotType = 1;
options.ScaleParam = 1;
warning('off', 'all');

%Solve optimization problems:
[Objectives, Parameters, Points, GraphHandle]=riskconstrparam ([],'cvar_risk', [], [], [], [], ...
    0.95, Hmatr, [], [], -dmatr,  0.075, [], [], Aeqmatr, beqvec, lbvec, [], 'r', [],[],N_Par,...
    [], [], [], [], options);
                                               
%Display results:
fprintf('Number of Points: %d\n', length(Parameters));
%Display objective:
fprintf('Parameters  Objectives:\n');
fprintf('%f\t%f\n', [Parameters; Objectives]);
%Display optimal point:
fprintf('Optimal Points:\n');
disp(Points);